ssh-api
=======

Bash API for `ssh`, `scp` and `rsync`.

`host` command is required, considere install `dnsutils`.

```bash
sudo apt install dnsutils
```

---

## rsync-api.sh

### rsync-api.sh / Functions

* `ssh_api_rsync_directory_from_host` ( `ssh_user` `ssh_host` `ssh_remote_dir` `local_directory` ):
TODOC

* `ssh_api_rsync_directory_locally` ( `source_directory` `destination_directory` ):
Use rsync to copy from a local directory to a other local directory

* `ssh_api_rsync_directory_to_host` ( `local_directory` `ssh_user` `ssh_host` `ssh_remote_dir` ):
Use rsync to copy from a local directory to a remote directory

* `ssh_api_rsync_file_from_host` ( `ssh_user` `ssh_host` `ssh_remote_file` `local_directory` ):
Copy file using rsync from local host to remote host directory.

* `ssh_api_rsync_file_to_host` ( `local_file` `ssh_user` `ssh_host` `ssh_remote_dir` ):
Copy file using rsync from remote host to local host directory.

---

## rsync-config-api.sh

Configuration helpers

### rsync-config-api.sh / Configuration

* `RSYNC_CHECK_DESTINATION` : If set to `false` disable distination check before running rsync.
* `RSYNC_OPTS` : DEPRECATED
* `RSYNC_RESOLV_HOST` : If set to `false`, don't try to resolv hostname to ip before running ssh.
* `SSH_API_RSYNC_DEBUG` : If set to `true` display rsync commands using `set -x`. (RSYNC_VERBOSE is deprecated)

### rsync-config-api.sh / Functions

* `getRSYNC_CHECK_DESTINATION` (): Use to check content of `RSYNC_CHECK_DESTINATION`
* `getRSYNC_OPTS` (): DEPRECATED 2023-01-11
* `ssh_api_is_SSH_API_RSYNC_DEBUG` () : Use to check content of `SSH_API_RSYNC_DEBUG`
* `ssh_api_RSYNC_OPTS_ARRAY_add_opts` (...): Add rsync options from an array
* `ssh_api_RSYNC_OPTS_ARRAY_add_opts_from_string` ( `str` ): Add rsync options from a string
* `ssh_api_RSYNC_OPTS_ARRAY_set_opts` (...): Set rsync options from an array
* `ssh_api_RSYNC_OPTS_ARRAY_set_opts_from_string` ( `str` ): Set rsync options from a string
* `ssh_api_RSYNC_OPTS_ARRAY_show_opts` (): Display current options

---

## rsync-generic-main.sh

### rsync-generic-main.sh / function

* `ssh_api_rsync_generic_main` : TODOC

---

## scp-api.sh (deprecated)

**scp** is deprecated.

### scp-api.sh / Configuration (deprecated)

* `SSH_API_SCP_OPTS` : Allow to customize scp calls (see man scp)
* `SSH_API_SCP_DEBUG` : If set to `true` display scp commands using `set -x`.

### scp-api.sh / Functions (deprecated)

* `ssh_api_scp_directory_to_host` ( `local_directory` `ssh_user` `ssh_host` `ssh_remote_dir` ):
Copy directory using scp from local host to remote

* `ssh_api_scp_from_host` ( `ssh_user` `ssh_host` `ssh_remote_file` `local_file` ):
Copy file using scp from remote host to local host

* `ssh_api_scp_to_host` ( `local_file` `ssh_user` `ssh_host` `ssh_remote_file` ):
Copy file using scp from local host to remote host (deprecated use `ssh_api_rsync_file_to_host`( `local_file` `ssh_user` `ssh_host` `ssh_remote_dir` ) instead)

---

## ssh-api.sh

### ssh-api.sh / Functions:

* `ssh_api_do_ssh` ( `ssh_user` `ssh_host` `ssh_cmd` ):
TODOC

* `ssh_api_update_known_hosts` ( `host` ):
Add add remove any previous declarations of `host` to `~/.ssh/known_hosts`

* `ssh_api_test_remote_directory` ( `ssh_user` `ssh_host` `ssh_remote_dir` ): TODOC

---

## ssh-common-api.sh

### ssh-common-api.sh / Configuration:

* If `SSH_API_DISABLED_SSH_AGENT_AUTO_START` is set to `true` then don't run `ssh_api_start_ssh_agent` when sourcing file.
* If `SSH_API_DISABLED_SSH_AGENT_ADD_PRIVATE_KEY` is set to `true` then don't try to run `ssh-add` when sourcing file.
* `SSH_API_SSH_DEBUG` : If set to `true` display ssh extra debug lines.

### ssh-common-api.sh / Functions:

* `getRSYNC_RESOLV_HOST` (): Use to check content of `RSYNC_RESOLV_HOST`
* `ssh_api_initialize_SSH_USER_or_exit` (): TODOC
* `ssh_api_is_SSH_API_SSH_DEBUG` (): Check `SSH_API_SSH_DEBUG` value.
* `ssh_api_print_env` () :
* `ssh_api_start_ssh_agent` (): start ssh-agent if needed
* `ssh_api_update_known_hosts` ():

---

## ssh-config-api.sh

### ssh-config-api.sh / Functions:

* `ssh_api_get_SSH_OPTS` (): DEPRECATED 2023-01-13
* `ssh_api_SSH_OPTS_ARRAY_add_opts` ():
* `ssh_api_SSH_OPTS_ARRAY_add_opts_from_string` ():
* `ssh_api_SSH_OPTS_ARRAY_set_opts` ():
* `ssh_api_SSH_OPTS_ARRAY_set_opts_from_string` ():
