#!/bin/bash -e
#
# rsync-now:rsync-now-configuration-samples/rsync-configuration-template-generator.sh
#
set -u
set -o pipefail

function build_entries_without_duplicates_and_if_exists {
  local dirname=
  local dir=

  for dirname in DESKTOP DOWNLOAD TEMPLATES PUBLICSHARE DOCUMENTS MUSIC PICTURES VIDEOS ; do
    dir="$( xdg-user-dir "${dirname}" )"

    if [ -d "${dir}" ] ; then
      echo "${dirname} ${dir}"
    else
      echo "# WARN: ${dirname} - '${dir}' not found." >&2
    fi
  done | sort --key=2 | uniq --skip-fields 1 | cut -d ' ' -f1
}

function generate_config_code {
  local dirname=

  while read -r dirname ; do
    echo "rsync-now-config -C DEFAULT --new '$( xdg-user-dir "${dirname}" )' '\${backups_dir}/${dirname}' 'Backup DOCUMENTS ${dirname}'"
  done < <( build_entries_without_duplicates_and_if_exists )
}

generate_config_code
